Index: /LMDZ5/branches/testing/libf/phylmd/pbl_surface_mod.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/pbl_surface_mod.F90	(revision 2219)
+++ /LMDZ5/branches/testing/libf/phylmd/pbl_surface_mod.F90	(revision 2220)
@@ -33,5 +33,5 @@
   REAL, ALLOCATABLE, DIMENSION(:), PRIVATE, SAVE     :: fder   ! flux drift
   !$OMP THREADPRIVATE(fder)
-  REAL, ALLOCATABLE, DIMENSION(:,:), PRIVATE, SAVE   :: snow   ! snow at surface
+  REAL, ALLOCATABLE, DIMENSION(:,:), PUBLIC, SAVE   :: snow   ! snow at surface
   !$OMP THREADPRIVATE(snow)
   REAL, ALLOCATABLE, DIMENSION(:,:), PRIVATE, SAVE   :: qsurf  ! humidity at surface
@@ -172,5 +172,5 @@
        debut,     lafin,                              &
        rlon,      rlat,      rugoro,   rmu0,          &
-       zsig,      sollwd_m,  pphi,     cldt,          &
+       zsig,      lwdown_m,  pphi,     cldt,          &
        rain_f,    snow_f,    solsw_m,  sollw_m,       &
        t,         q,         u,        v,             &
@@ -182,5 +182,5 @@
        pplay,     paprs,     pctsrf,                  &
        ts,        alb1, alb2,ustar, u10m, v10m,wstar, &
-       lwdown_m,  cdragh,    cdragm,   zu1,    zv1,   &
+       cdragh,    cdragm,   zu1,    zv1,              &
        alb1_m,    alb2_m,    zxsens,   zxevap,        &
        alb3_lic,  runoff,    snowhgt,   qsnow,     to_ice,    sissnow,  &
@@ -327,5 +327,5 @@
 ! Martin
     REAL, DIMENSION(klon),        INTENT(IN)        :: zsig    ! slope
-    REAL, DIMENSION(klon),        INTENT(IN)        :: sollwd_m ! net longwave radiation at mean s    
+    REAL, DIMENSION(klon),        INTENT(IN)        :: lwdown_m ! downward longwave radiation at mean s    
     REAL, DIMENSION(klon),        INTENT(IN)        :: cldt    ! total cloud fraction
     REAL, DIMENSION(klon,klev),   INTENT(IN)        :: pphi    ! geopotential (m2/s2)
@@ -367,5 +367,4 @@
 ! Output variables
 !****************************************************************************************
-    REAL, DIMENSION(klon),        INTENT(OUT)       :: lwdown_m   ! Downcoming longwave radiation
     REAL, DIMENSION(klon),        INTENT(OUT)       :: cdragh     ! drag coefficient for T and Q
     REAL, DIMENSION(klon),        INTENT(OUT)       :: cdragm     ! drag coefficient for wind
@@ -780,5 +779,4 @@
     ! Martin
     REAL, DIMENSION(klon, nbsrf)       :: sollwd ! net longwave radiation at surface
-    REAL, DIMENSION(klon)              :: ysollwd
     REAL, DIMENSION(klon)              :: ytoice
     REAL, DIMENSION(klon)              :: ysnowhgt, yqsnow, ysissnow, yrunoff
@@ -855,5 +853,4 @@
 ! 2a) Initialization of all argument variables with INTENT(OUT)
 !****************************************************************************************
- lwdown_m(:)=0.
  cdragh(:)=0. ; cdragm(:)=0.
  zu1(:)=0. ; zv1(:)=0.
@@ -938,5 +935,5 @@
     ! Martin
     ysnowhgt = 0.0; yqsnow = 0.0     ; yrunoff = 0.0   ; ytoice =0.0
-    yalb3_new = 0.0  ; ysissnow = 0.0  ; ysollwd = 0.0
+    yalb3_new = 0.0  ; ysissnow = 0.0 
     ypphi = 0.0   ; ycldt = 0.0      ; yrmu0 = 0.0
     ! Martin
@@ -1109,17 +1106,16 @@
        DO i = 1, klon
           sollw(i,nsrf) = sollw_m(i) + 4.0*RSIGMA*ztsol(i)**3 * (ztsol(i)-ts(i,nsrf))
-          ! Martin
-          sollwd(i,nsrf)= sollwd_m(i)
-          ! Martin
+
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+!         ! Martin
+! Apparently introduced for sisvat but not used
+!         sollwd(i,nsrf)= sollwd_m(i)
+!         ! Martin
+!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
+
           solsw(i,nsrf) = solsw_m(i) * (1.-alb(i,nsrf)) / (1.-alb_m(i))
        ENDDO
     ENDDO
 
-
-! Downwelling longwave radiation at mean surface
-    lwdown_m(:) = 0.0
-    DO i = 1, klon
-       lwdown_m(i) = sollw_m(i) + RSIGMA*ztsol(i)**4
-    ENDDO
 
 !****************************************************************************************
@@ -1180,4 +1176,5 @@
           yagesno(j) = agesno(i,nsrf)
           yfder(j)   = fder(i)
+          ylwdown(j) = lwdown_m(i)
           ysolsw(j)  = solsw(i,nsrf)
           ysollw(j)  = sollw(i,nsrf)
@@ -1703,9 +1700,5 @@
      
        CASE(is_ter)
-          ! ylwdown : to be removed, calculation is now done at land surface in surf_land
-          ylwdown(:)=0.0
-          DO i=1,knon
-             ylwdown(i)=lwdown_m(ni(i))
-          END DO
+!          print*,"DEBUGTS",yts(knon/2),ylwdown(knon/2)
           CALL surf_land(itap, dtime, date0, jour, knon, ni,&
                rlon, rlat, &
@@ -1746,5 +1739,5 @@
           CALL surf_landice(itap, dtime, knon, ni, &
                rlon, rlat, debut, lafin, &
-               yrmu0, ysollwd, yalb, ypphi(:,1), &
+               yrmu0, ylwdown, yalb, ypphi(:,1), &
                ysolsw, ysollw, yts, ypplay(:,1), &
                ycdragh, ycdragm, yrain_f, ysnow_f, yt(:,1), yq(:,1),&
Index: /LMDZ5/branches/testing/libf/phylmd/phyaqua_mod.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/phyaqua_mod.F90	(revision 2219)
+++ /LMDZ5/branches/testing/libf/phylmd/phyaqua_mod.F90	(revision 2220)
@@ -238,5 +238,5 @@
     rugos = rugos_omp
     WRITE (*, *) 'iniaqua: rugos=', rugos
-    zmasq(:) = pctsrf(:, is_oce)
+    zmasq(:) = pctsrf(:, is_ter)
 
     ! pctsrf_pot(:,is_oce) = 1. - zmasq(:)
@@ -538,34 +538,73 @@
       dims(2) = ntim
 
-      ! cc      ierr = NF_DEF_VAR (nid, "TEMPS", NF_DOUBLE, 1,ntim, id_tim)
+#ifdef NC_DOUBLE
+      ierr = nf_def_var(nid, 'TEMPS', nf_double, 1, ntim, id_tim)
+#else
       ierr = nf_def_var(nid, 'TEMPS', nf_float, 1, ntim, id_tim)
+#endif
       ierr = nf_put_att_text(nid, id_tim, 'title', 17, 'Jour dans l annee')
-      ! cc      ierr = NF_DEF_VAR (nid, "NAT", NF_DOUBLE, 2,dims, id_NAT)
+
+#ifdef NC_DOUBLE
+      ierr = nf_def_var(nid, 'NAT', nf_double, 2, dims, id_nat)
+#else
       ierr = nf_def_var(nid, 'NAT', nf_float, 2, dims, id_nat)
+#endif
       ierr = nf_put_att_text(nid, id_nat, 'title', 23, &
         'Nature du sol (0,1,2,3)')
-      ! cc      ierr = NF_DEF_VAR (nid, "SST", NF_DOUBLE, 2,dims, id_SST)
+
+#ifdef NC_DOUBLE
+      ierr = nf_def_var(nid, 'SST', nf_double, 2, dims, id_sst)
+#else
       ierr = nf_def_var(nid, 'SST', nf_float, 2, dims, id_sst)
+#endif
       ierr = nf_put_att_text(nid, id_sst, 'title', 35, &
         'Temperature superficielle de la mer')
-      ! cc      ierr = NF_DEF_VAR (nid, "BILS", NF_DOUBLE, 2,dims, id_BILS)
+
+#ifdef NC_DOUBLE
+      ierr = nf_def_var(nid, 'BILS', nf_double, 2, dims, id_bils)
+#else
       ierr = nf_def_var(nid, 'BILS', nf_float, 2, dims, id_bils)
+#endif
       ierr = nf_put_att_text(nid, id_bils, 'title', 32, &
         'Reference flux de chaleur au sol')
-      ! cc      ierr = NF_DEF_VAR (nid, "ALB", NF_DOUBLE, 2,dims, id_ALB)
+
+#ifdef NC_DOUBLE
+      ierr = nf_def_var(nid, 'ALB', nf_double, 2, dims, id_alb)
+#else
       ierr = nf_def_var(nid, 'ALB', nf_float, 2, dims, id_alb)
+#endif
       ierr = nf_put_att_text(nid, id_alb, 'title', 19, 'Albedo a la surface')
-      ! cc      ierr = NF_DEF_VAR (nid, "RUG", NF_DOUBLE, 2,dims, id_RUG)
+
+#ifdef NC_DOUBLE
+      ierr = nf_def_var(nid, 'RUG', nf_double, 2, dims, id_rug)
+#else
       ierr = nf_def_var(nid, 'RUG', nf_float, 2, dims, id_rug)
+#endif
       ierr = nf_put_att_text(nid, id_rug, 'title', 8, 'Rugosite')
 
+#ifdef NC_DOUBLE
+      ierr = nf_def_var(nid, 'FTER', nf_double, 2, dims, id_fter)
+#else
       ierr = nf_def_var(nid, 'FTER', nf_float, 2, dims, id_fter)
-      ierr = nf_put_att_text(nid, id_fter, 'title', 8, 'Frac. Terre')
+#endif
+      ierr = nf_put_att_text(nid, id_fter, 'title',10,'Frac. Land')
+#ifdef NC_DOUBLE
+      ierr = nf_def_var(nid, 'FOCE', nf_double, 2, dims, id_foce)
+#else
       ierr = nf_def_var(nid, 'FOCE', nf_float, 2, dims, id_foce)
-      ierr = nf_put_att_text(nid, id_foce, 'title', 8, 'Frac. Terre')
+#endif
+      ierr = nf_put_att_text(nid, id_foce, 'title',11,'Frac. Ocean')
+#ifdef NC_DOUBLE
+      ierr = nf_def_var(nid, 'FSIC', nf_double, 2, dims, id_fsic)
+#else
       ierr = nf_def_var(nid, 'FSIC', nf_float, 2, dims, id_fsic)
-      ierr = nf_put_att_text(nid, id_fsic, 'title', 8, 'Frac. Terre')
+#endif
+      ierr = nf_put_att_text(nid, id_fsic, 'title',13,'Frac. Sea Ice')
+#ifdef NC_DOUBLE
+      ierr = nf_def_var(nid, 'FLIC', nf_double, 2, dims, id_flic)
+#else
       ierr = nf_def_var(nid, 'FLIC', nf_float, 2, dims, id_flic)
-      ierr = nf_put_att_text(nid, id_flic, 'title', 8, 'Frac. Terre')
+#endif
+      ierr = nf_put_att_text(nid, id_flic, 'title',14,'Frac. Land Ice')
 
       ierr = nf_enddef(nid)
Index: /LMDZ5/branches/testing/libf/phylmd/phyetat0.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/phyetat0.F90	(revision 2219)
+++ /LMDZ5/branches/testing/libf/phylmd/phyetat0.F90	(revision 2220)
@@ -8,9 +8,9 @@
   USE fonte_neige_mod,  ONLY : fonte_neige_init
   USE pbl_surface_mod,  ONLY : pbl_surface_init
-  USE surface_data,     ONLY : type_ocean
+  USE surface_data,     ONLY : type_ocean, version_ocean
   USE phys_state_var_mod, ONLY : ancien_ok, clwcon, detr_therm, dtime, &
        du_gwd_rando, dv_gwd_rando, entr_therm, f0, falb1, falb2, fm_therm, &
        ftsol, pbl_tke, pctsrf, q_ancien, radpas, radsol, rain_fall, ratqs, &
-       rlat, rlon, rnebcon, rugoro, sig1, snow_fall, solaire_etat0, sollw, &
+       rlat, rlon, rnebcon, rugoro, sig1, snow_fall, solaire_etat0, sollw, sollwdown, &
        solsw, t_ancien, u_ancien, v_ancien, w01, wake_cstar, wake_deltaq, &
        wake_deltat, wake_delta_pbl_TKE, delta_tsurf, wake_fip, wake_pe, &
@@ -23,5 +23,5 @@
   USE carbon_cycle_mod, ONLY : carbon_cycle_tr, carbon_cycle_cpl, co2_send
   USE indice_sol_mod, only: nbsrf, is_ter, epsfra, is_lic, is_oce, is_sic
-  USE ocean_slab_mod, ONLY: tslab, ocean_slab_init
+  USE ocean_slab_mod, ONLY: tslab, seaice, tice, ocean_slab_init
 
   IMPLICIT none
@@ -37,4 +37,5 @@
   include "thermcell.h"
   include "compbl.h"
+  include "YOMCST.h"
   !======================================================================
   CHARACTER*(*) fichnom
@@ -53,4 +54,5 @@
   REAL fractint(klon)
   REAL trs(klon, nbtr)
+  REAL zts(klon)
 
   CHARACTER*6 ocean_in
@@ -513,4 +515,25 @@
   PRINT*, 'Rayonnement IF au sol sollw:', xmin, xmax
 
+  CALL get_field("sollwdown", sollwdown, found)
+  IF (.NOT. found) THEN
+     PRINT*, 'phyetat0: Le champ <sollwdown> est absent'
+     PRINT*, 'mis a zero'
+     sollwdown = 0.
+     zts=0.
+     do nsrf=1,nbsrf
+        zts(:)=zts(:)+ftsol(:,nsrf)*pctsrf(:,nsrf)
+     enddo
+     sollwdown(:)=sollw(:)+RSIGMA*zts(:)**4
+  ENDIF
+!  print*,'TS SOLL',zts(klon/2),sollw(klon/2),sollwdown(klon/2)
+  xmin = 1.0E+20
+  xmax = -1.0E+20
+  DO i = 1, klon
+     xmin = MIN(sollwdown(i), xmin)
+     xmax = MAX(sollwdown(i), xmax)
+  ENDDO
+  PRINT*, 'Rayonnement IF au sol sollwdown:', xmin, xmax
+
+
   ! Lecture derive des flux:
 
@@ -1137,7 +1160,7 @@
   ! Initialize Slab variables
   IF ( type_ocean == 'slab' ) THEN
-      ALLOCATE(tslab(klon,nslay), stat=ierr)
-      IF (ierr /= 0) CALL abort_gcm &
-         ('phyetat0', 'pb allocation tslab', 1)
+      print*, "calling slab_init"
+      CALL ocean_slab_init(dtime, pctsrf)
+      ! tslab
       CALL get_field("tslab", tslab, found)
       IF (.NOT. found) THEN 
@@ -1145,9 +1168,25 @@
           PRINT*, "Initialisation a tsol_oce"
           DO i=1,nslay
-              tslab(:,i)=ftsol(:,is_oce)
+              tslab(:,i)=MAX(ftsol(:,is_oce),271.35)
           END DO
       END IF 
-      print*, "calling slab_init"
-      CALL ocean_slab_init(dtime, pctsrf)
+      ! Sea ice variables
+      IF (version_ocean == 'sicINT') THEN
+          CALL get_field("slab_tice", tice, found)
+          IF (.NOT. found) THEN 
+              PRINT*, "phyetat0: Le champ <tice> est absent"
+              PRINT*, "Initialisation a tsol_sic"
+                  tice(:)=ftsol(:,is_sic)
+          END IF 
+          CALL get_field("seaice", seaice, found)
+          IF (.NOT. found) THEN
+              PRINT*, "phyetat0: Le champ <seaice> est absent"
+              PRINT*, "Initialisation a 0/1m suivant fraction glace"
+              seaice(:)=0.
+              WHERE (pctsrf(:,is_sic).GT.EPSFRA)
+                  seaice=917.
+              END WHERE
+          END IF
+      END IF !sea ice INT
   END IF ! Slab        
 
Index: /LMDZ5/branches/testing/libf/phylmd/phyredem.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/phyredem.F90	(revision 2219)
+++ /LMDZ5/branches/testing/libf/phylmd/phyredem.F90	(revision 2220)
@@ -16,5 +16,5 @@
   USE indice_sol_mod
   USE surface_data
-  USE ocean_slab_mod, ONLY : tslab
+  USE ocean_slab_mod, ONLY : tslab, seaice, tice, fsic
 
   IMPLICIT none
@@ -107,4 +107,12 @@
   ! BP ajout des fraction de chaque sous-surface
 
+  ! Get last fractions from slab ocean
+  IF (type_ocean == 'slab' .AND. version_ocean == "sicINT") THEN
+      WHERE (1.-zmasq(:).GT.EPSFRA)
+          pctsrf(:,is_oce)=(1.-fsic(:))*(1.-zmasq(:))
+          pctsrf(:,is_sic)=fsic(:)*(1.-zmasq(:))
+      END WHERE
+  END IF
+
   ! 1. fraction de terre 
 
@@ -209,4 +217,6 @@
 
   CALL put_field("sollw", "Rayonnement IF a la surface", sollw)
+
+  CALL put_field("sollwdown", "Rayonnement down IF a la surface", sollw)
 
   CALL put_field("fder", "Derive de flux", fder)
@@ -350,4 +360,8 @@
   IF (type_ocean == 'slab') THEN
       CALL put_field("tslab", "Slab ocean temperature", tslab)
+      IF (version_ocean == 'sicINT') THEN
+          CALL put_field("seaice", "Slab seaice (kg/m2)", seaice)
+          CALL put_field("slab_tice", "Slab sea ice temperature", tice)
+      END IF
   END IF
 
Index: /LMDZ5/branches/testing/libf/phylmd/phys_local_var_mod.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/phys_local_var_mod.F90	(revision 2219)
+++ /LMDZ5/branches/testing/libf/phylmd/phys_local_var_mod.F90	(revision 2220)
@@ -35,4 +35,6 @@
       REAL, SAVE, ALLOCATABLE :: d_t_lsc(:,:),d_q_lsc(:,:),d_ql_lsc(:,:),d_qi_lsc(:,:)
       !$OMP THREADPRIVATE(d_t_lsc,d_q_lsc,d_ql_lsc,d_qi_lsc)
+      REAL, SAVE, ALLOCATABLE :: d_t_lwr(:,:),d_t_lw0(:,:),d_t_swr(:,:),d_t_sw0(:,:)
+      !$OMP THREADPRIVATE(d_t_lwr,d_t_lw0,d_t_swr,d_t_sw0)
       REAL, SAVE, ALLOCATABLE :: d_t_ajsb(:,:), d_q_ajsb(:,:)
       !$OMP THREADPRIVATE(d_t_ajsb, d_q_ajsb)
@@ -393,4 +395,6 @@
       allocate(d_t_wake(klon,klev),d_q_wake(klon,klev))
       allocate(d_t_lsc(klon,klev),d_q_lsc(klon,klev))
+      allocate(d_t_lwr(klon,klev),d_t_lw0(klon,klev))
+      allocate(d_t_swr(klon,klev),d_t_sw0(klon,klev))
       allocate(d_ql_lsc(klon,klev),d_qi_lsc(klon,klev))
       allocate(d_t_ajsb(klon,klev),d_q_ajsb(klon,klev))
@@ -599,4 +603,6 @@
       deallocate(d_t_wake,d_q_wake)
       deallocate(d_t_lsc,d_q_lsc)
+      deallocate(d_t_lwr,d_t_lw0)
+      deallocate(d_t_swr,d_t_sw0)
       deallocate(d_ql_lsc,d_qi_lsc)
       deallocate(d_t_ajsb,d_q_ajsb)
Index: /LMDZ5/branches/testing/libf/phylmd/phys_output_ctrlout_mod.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/phys_output_ctrlout_mod.F90	(revision 2219)
+++ /LMDZ5/branches/testing/libf/phylmd/phys_output_ctrlout_mod.F90	(revision 2220)
@@ -465,8 +465,14 @@
   TYPE(ctrl_out), SAVE :: o_slab_bils = ctrl_out((/ 1, 1, 10, 10, 10, 10, 11, 11, 11 /), &
     'slab_bils', 'flux atmos - slab ponderes foce', 'W/m2', (/ ('', i=1, 9) /))
+  TYPE(ctrl_out), SAVE :: o_slab_bilg = ctrl_out((/ 1, 1, 10, 10, 10, 10, 11, 11, 11 /), &
+    'slab_bilg', 'flux glace - slab ponderes fsic', 'W/m2', (/ ('', i=1, 9) /))
   TYPE(ctrl_out), SAVE :: o_slab_qflux = ctrl_out((/ 1, 1, 10, 10, 10, 10, 11, 11, 11 /), &
     'slab_qflux', 'Correction flux slab', 'W/m2', (/ ('', i=1, 9) /))
   TYPE(ctrl_out), SAVE :: o_tslab = ctrl_out((/ 1, 1, 10, 10, 10, 10, 11, 11, 11 /), &
     'tslab', 'Temperature ocean slab', 'K', (/ ('', i=1, 9) /))
+  TYPE(ctrl_out), SAVE :: o_slab_tice = ctrl_out((/ 1, 1, 10, 10, 10, 10, 11, 11, 11 /), &
+    'slab_tice', 'Temperature banquise slab', 'K', (/ ('', i=1, 9) /))
+  TYPE(ctrl_out), SAVE :: o_slab_sic = ctrl_out((/ 1, 1, 10, 10, 10, 10, 11, 11, 11 /), &
+    'seaice', 'Epaisseur banquise slab', 'kg/m2', (/ ('', i=1, 9) /))
   TYPE(ctrl_out), SAVE :: o_ale_bl = ctrl_out((/ 1, 1, 1, 10, 10, 10, 11, 11, 11 /), &
     'ale_bl', 'ALE BL', 'm2/s2', (/ ('', i=1, 9) /))
@@ -1008,4 +1014,10 @@
       ctrl_out((/ 10, 10, 10, 10, 10, 10, 11, 11, 11 /),'ages_oce',"Snow age", "day", (/ ('', i=1, 9) /)), &
       ctrl_out((/ 3, 10, 10, 10, 10, 10, 11, 11, 11 /),'ages_sic',"Snow age", "day", (/ ('', i=1, 9) /)) /)
+
+  TYPE(ctrl_out), SAVE, DIMENSION(4) :: o_snow_srf     = (/ &
+      ctrl_out((/ 10, 10, 10, 10, 10, 10, 11, 11, 11 /),'snow_ter', "Snow", "kg/m2", (/ ('', i=1, 9) /)), &
+      ctrl_out((/ 3, 10, 10, 10, 10, 10, 11, 11, 11 /),'snow_lic', "Snow", "kg/m2", (/ ('', i=1, 9) /)), &
+      ctrl_out((/ 10, 10, 10, 10, 10, 10, 11, 11, 11 /),'snow_oce',"Snow", "kg/m2", (/ ('', i=1, 9) /)), &
+      ctrl_out((/ 3, 10, 10, 10, 10, 10, 11, 11, 11 /),'snow_sic',"Snow", "kg/m2", (/ ('', i=1, 9) /)) /)
 
   TYPE(ctrl_out), SAVE, DIMENSION(4) :: o_rugs_srf     = (/ &
Index: /LMDZ5/branches/testing/libf/phylmd/phys_output_write_mod.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/phys_output_write_mod.F90	(revision 2219)
+++ /LMDZ5/branches/testing/libf/phylmd/phys_output_write_mod.F90	(revision 2220)
@@ -80,4 +80,5 @@
          o_alp_bl_conv, o_alp_bl_stat, &
          o_slab_qflux, o_tslab, o_slab_bils, &
+         o_slab_bilg, o_slab_sic, o_slab_tice, &
          o_weakinv, o_dthmin, o_cldtau, &
          o_cldemi, o_pr_con_l, o_pr_con_i, &
@@ -113,5 +114,5 @@
          o_rnebls, o_rhum, o_ozone, o_ozone_light, &
          o_dtphy, o_dqphy, o_albe_srf, o_rugs_srf, &
-         o_ages_srf, o_alb1, o_alb2, o_tke, &
+         o_ages_srf, o_snow_srf, o_alb1, o_alb2, o_tke, &
          o_tke_max, o_kz, o_kz_max, o_clwcon, &
          o_dtdyn, o_dqdyn, o_dudyn, o_dvdyn, &
@@ -166,6 +167,6 @@
          wake_deltaq, ftd, fqd, ale_bl_trig, albsol1, &
          rnebcon, wo, falb1, albsol2, coefh, clwcon0, &
-         ratqs, entr_therm, zqasc, detr_therm, f0, heat, &
-         heat0, cool, cool0, lwup, lwdn, lwup0, coefm, &
+         ratqs, entr_therm, zqasc, detr_therm, f0, &
+         lwup, lwdn, lwup0, coefm, &
          swupp, lwupp, swup0p, lwup0p, swdnp, lwdnp, &
          swdn0p, lwdn0p, tnondef, O3sumSTD, uvsumSTD, &
@@ -215,4 +216,5 @@
          d_u_ajs, d_v_ajs, &
          d_u_con, d_v_con, d_q_con, d_q_ajs, d_t_lsc, &
+         d_t_lwr,d_t_lw0,d_t_swr,d_t_sw0, &
          d_t_eva, d_q_lsc, beta_prec, d_t_lscth, &
          d_t_lscst, d_q_lscth, d_q_lscst, plul_th, &
@@ -226,9 +228,10 @@
          bils_ec,bils_ech, bils_tke, bils_kinetic, bils_latent, bils_enthalp, &
          itau_con, nfiles, clef_files, nid_files, zvstr_gwd_rando
-    USE ocean_slab_mod, only: tslab, slab_bils
+    USE ocean_slab_mod, only: tslab, slab_bils, slab_bilg, tice, seaice
+    USE pbl_surface_mod, only: snow
     USE indice_sol_mod, only: nbsrf
     USE infotrac, only: nqtot, nqo, type_trac
     USE comgeomphy, only: airephy
-    USE surface_data, only: type_ocean, ok_veget, ok_snow
+    USE surface_data, only: type_ocean, version_ocean, ok_veget, ok_snow
 !    USE aero_mod, only: naero_spc
     USE aero_mod, only: naero_tot, id_STRAT_phy
@@ -399,5 +402,5 @@
        CALL histwrite_phy(o_pluc, zx_tmp_fi2d)
        CALL histwrite_phy(o_snow, snow_fall)
-       CALL histwrite_phy(o_msnow, snow_o)
+       CALL histwrite_phy(o_msnow, zxsnow)
        CALL histwrite_phy(o_fsnow, zfra_o)
        CALL histwrite_phy(o_evap, evap)
@@ -513,5 +516,5 @@
 
        IF (ok_snow) THEN
-          CALL histwrite_phy(o_snowsrf, zxsnow)
+          CALL histwrite_phy(o_snowsrf, snow_o)
           CALL histwrite_phy(o_qsnow, qsnow)
           CALL histwrite_phy(o_snowhgt,snowhgt)
@@ -754,4 +757,9 @@
               CALL histwrite_phy(o_tslab, tslab)
           END IF
+          IF (version_ocean=='sicINT') THEN
+              CALL histwrite_phy(o_slab_bilg, slab_bilg)
+              CALL histwrite_phy(o_slab_tice, tice)
+              CALL histwrite_phy(o_slab_sic, seaice)
+          END IF
        ENDIF !type_ocean == force/slab
        CALL histwrite_phy(o_weakinv, weak_inversion)
@@ -969,4 +977,6 @@
           IF (vars_defined) zx_tmp_fi2d(1 : klon) = agesno( 1 : klon, nsrf)
           CALL histwrite_phy(o_ages_srf(nsrf), zx_tmp_fi2d)
+          IF (vars_defined) zx_tmp_fi2d(1 : klon) = snow( 1 : klon, nsrf)
+          CALL histwrite_phy(o_snow_srf(nsrf), zx_tmp_fi2d)
        ENDDO !nsrf=1, nbsrf
        CALL histwrite_phy(o_alb1, albsol1)
@@ -1127,11 +1137,11 @@
        IF(vars_defined) zx_tmp_fi3d(1:klon,1:klev)=d_q_ajsb(1:klon,1:klev)/pdtphys
        CALL histwrite_phy(o_dqajs, zx_tmp_fi3d)
-       IF(vars_defined) zx_tmp_fi3d(1:klon,1:klev)=heat(1:klon,1:klev)/RDAY
+       IF(vars_defined) zx_tmp_fi3d(1:klon,1:klev)=d_t_swr(1:klon,1:klev)/pdtphys
        CALL histwrite_phy(o_dtswr, zx_tmp_fi3d)
-       IF(vars_defined) zx_tmp_fi3d(1:klon,1:klev)=heat0(1:klon,1:klev)/RDAY
+       IF(vars_defined) zx_tmp_fi3d(1:klon,1:klev)=d_t_sw0(1:klon,1:klev)/pdtphys
        CALL histwrite_phy(o_dtsw0, zx_tmp_fi3d)
-       IF(vars_defined) zx_tmp_fi3d(1:klon,1:klev)=-1.*cool(1:klon,1:klev)/RDAY
+       IF(vars_defined) zx_tmp_fi3d(1:klon,1:klev)=d_t_lwr(1:klon,1:klev)/pdtphys
        CALL histwrite_phy(o_dtlwr, zx_tmp_fi3d)
-       IF(vars_defined) zx_tmp_fi3d(1:klon,1:klev)=-1.*cool0(1:klon,1:klev)/RDAY
+       IF(vars_defined) zx_tmp_fi3d(1:klon,1:klev)=d_t_lw0(1:klon,1:klev)/pdtphys
        CALL histwrite_phy(o_dtlw0, zx_tmp_fi3d)
        IF(vars_defined) zx_tmp_fi3d(1:klon,1:klev)=d_t_ec(1:klon,1:klev)/pdtphys
@@ -1193,6 +1203,6 @@
        CALL histwrite_phy(o_tnt, zx_tmp_fi3d)
        IF(vars_defined) THEN
-          zx_tmp_fi3d(1:klon,1:klev)=heat(1:klon,1:klev)/RDAY - &
-               cool(1:klon,1:klev)/RDAY
+          zx_tmp_fi3d(1:klon,1:klev)=d_t_swr(1:klon,1:klev)/pdtphys + &
+               d_t_lwr(1:klon,1:klev)/pdtphys
        ENDIF
        CALL histwrite_phy(o_tntr, zx_tmp_fi3d)
Index: /LMDZ5/branches/testing/libf/phylmd/phys_state_var_mod.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/phys_state_var_mod.F90	(revision 2219)
+++ /LMDZ5/branches/testing/libf/phylmd/phys_state_var_mod.F90	(revision 2220)
@@ -60,4 +60,6 @@
       REAL, ALLOCATABLE, SAVE :: clwcon(:,:),rnebcon(:,:)
 !$OMP THREADPRIVATE(clwcon,rnebcon)
+      REAL, ALLOCATABLE, SAVE :: qtc_cv(:,:),sigt_cv(:,:)
+!$OMP THREADPRIVATE(qtc_cv,sigt_cv)
       REAL, ALLOCATABLE, SAVE :: ratqs(:,:)
 !$OMP THREADPRIVATE(ratqs)
@@ -416,4 +418,5 @@
 !!! Rom P <<<
       ALLOCATE(clwcon(klon,klev),rnebcon(klon,klev))
+      ALLOCATE(qtc_cv(klon,klev),sigt_cv(klon,klev))
       ALLOCATE(ratqs(klon,klev))
       ALLOCATE(pbl_tke(klon,klev+1,nbsrf+1))
@@ -566,4 +569,5 @@
       deallocate(zthe, zpic, zval)
       deallocate(rugoro, t_ancien, q_ancien, clwcon, rnebcon)
+      deallocate(qtc_cv,sigt_cv)
       deallocate(        u_ancien, v_ancien                 )
       deallocate(        tr_ancien)                           !RomP
Index: /LMDZ5/branches/testing/libf/phylmd/physiq.F90
===================================================================
--- /LMDZ5/branches/testing/libf/phylmd/physiq.F90	(revision 2219)
+++ /LMDZ5/branches/testing/libf/phylmd/physiq.F90	(revision 2220)
@@ -636,7 +636,7 @@
   !$OMP THREADPRIVATE(fact_cldcon,facttemps)
 
-  integer iflag_cldcon
-  save iflag_cldcon
-  !$OMP THREADPRIVATE(iflag_cldcon)
+  integer iflag_cldth
+  save iflag_cldth
+  !$OMP THREADPRIVATE(iflag_cldth)
   logical ptconv(klon,klev)
   !IM cf. AM 081204 BEG
@@ -913,5 +913,5 @@
           solarlong0,seuil_inversion, &
           fact_cldcon, facttemps,ok_newmicro,iflag_radia, &
-          iflag_cldcon,iflag_ratqs,ratqsbas,ratqshaut,tau_ratqs, &
+          iflag_cldth,iflag_ratqs,ratqsbas,ratqshaut,tau_ratqs, &
           ok_ade, ok_aie, ok_cdnc, aerosol_couple,  &
           flag_aerosol, flag_aerosol_strat, new_aod, &
@@ -1014,6 +1014,6 @@
      print*,'CYCLE_DIURNE', cycle_diurne
      !
-     IF (iflag_con.EQ.2.AND.iflag_cldcon.GT.-1) THEN
-        abort_message = 'Tiedtke needs iflag_cldcon=-2 or -1'
+     IF (iflag_con.EQ.2.AND.iflag_cldth.GT.-1) THEN
+        abort_message = 'Tiedtke needs iflag_cldth=-2 or -1'
         CALL abort_gcm (modname,abort_message,1)
      ENDIF
@@ -1130,5 +1130,5 @@
                 ,alp_bl_prescr, ale_bl_prescr)
            ! 11/09/06 rajout initialisation ALE et ALP du wake et PBL(YU)
-           !        print*,'apres ini_wake iflag_cldcon=', iflag_cldcon
+           !        print*,'apres ini_wake iflag_cldth=', iflag_cldth
         endif
 
@@ -1308,4 +1308,6 @@
              annee_ref, &
              day_ref,  &
+             day_ini, &
+             start_time, &
              itau_phy, &
              io_lon, &
@@ -1811,7 +1813,7 @@
 !>nrlmd+jyg
           pplay,     paprs,     pctsrf,             &
-          ftsol,falb1,falb2,ustar,u10m,v10m,wstar, &
-          sollwdown, cdragh,    cdragm,  u1,    v1, &
-          albsol1,   albsol2,   sens,    evap,   &
+          ftsol,falb1,falb2,ustar,u10m,v10m,wstar,  &
+          cdragh,    cdragm,  u1,    v1,            &
+          albsol1,   albsol2,   sens,    evap,      &
           albsol3_lic,runoff,   snowhgt,   qsnow, to_ice, sissnow, &
           zxtsol,    zxfluxlat, zt2m,    qsat2m,  &
@@ -2168,5 +2170,6 @@
              ftd,fqd,lalim_conv,wght_th, &
              ev, ep,epmlmMm,eplaMm, &
-             wdtrainA,wdtrainM,wght_cvfd)
+             wdtrainA,wdtrainM,wght_cvfd,qtc_cv,sigt_cv, &
+             tau_cld_cv,coefw_cld_cv)
         ! RomP <<<
 
@@ -2218,6 +2221,12 @@
      !   calcul des proprietes des nuages convectifs
      clwcon0(:,:)=fact_cldcon*clwcon0(:,:)
+     IF (iflag_cld_cv <= 1) THEN
      call clouds_gno &
           (klon,klev,q_seri,zqsat,clwcon0,ptconv,ratqsc,rnebcon0)
+     ELSE
+     call clouds_bigauss &
+          (klon,klev,q_seri,zqsat,qtc_cv,sigt_cv,ptconv,ratqsc,rnebcon0)
+     ENDIF
+
 
      ! =================================================================== c
@@ -2452,5 +2461,5 @@
   END IF
 
-  !      print*,'apres callwake iflag_cldcon=', iflag_cldcon
+  !      print*,'apres callwake iflag_cldth=', iflag_cldth
   !
   !===================================================================
@@ -2622,5 +2631,5 @@
               enddo
 
-           ELSE IF (iflag_trig_bl.eq.2) then
+           ELSE IF (iflag_trig_bl.ge.2) then
 
               do i=1,klon
@@ -2773,5 +2782,5 @@
   ! water distribution
   CALL  calcratqs(klon,klev,prt_level,lunout,        &
-       iflag_ratqs,iflag_con,iflag_cldcon,pdtphys,  &
+       iflag_ratqs,iflag_con,iflag_cldth,pdtphys,  &
        ratqsbas,ratqshaut,tau_ratqs,fact_cldcon,   &
        ptconv,ptconvth,clwcon0th, rnebcon0th,     &
@@ -2795,5 +2804,5 @@
        frac_impa, frac_nucl, beta_prec_fisrt, &
        prfl, psfl, rhcl,  &
-       zqasc, fraca,ztv,zpspsk,ztla,zthl,iflag_cldcon, &
+       zqasc, fraca,ztv,zpspsk,ztla,zthl,iflag_cldth, &
        iflag_ice_thermo)
   !
@@ -2851,10 +2860,10 @@
   !
   !IM cf FH
-  !     IF (iflag_cldcon.eq.-1) THEN ! seulement pour Tiedtke
-  IF (iflag_cldcon.le.-1) THEN ! seulement pour Tiedtke
+  !     IF (iflag_cldth.eq.-1) THEN ! seulement pour Tiedtke
+  IF (iflag_cldth.le.-1) THEN ! seulement pour Tiedtke
      snow_tiedtke=0.
      !     print*,'avant calcul de la pseudo precip '
-     !     print*,'iflag_cldcon',iflag_cldcon
-     if (iflag_cldcon.eq.-1) then
+     !     print*,'iflag_cldth',iflag_cldth
+     if (iflag_cldth.eq.-1) then
         rain_tiedtke=rain_con
      else
@@ -2889,5 +2898,5 @@
      ENDDO
 
-  ELSE IF (iflag_cldcon.ge.3) THEN
+  ELSE IF (iflag_cldth.ge.3) THEN
      !  On prend pour les nuages convectifs le max du calcul de la
      !  convection et du calcul du pas de temps precedent diminue d'un facteur
@@ -2932,4 +2941,6 @@
              tau_aero_sw_rrtm, piz_aero_sw_rrtm, cg_aero_sw_rrtm,  &
              tausum_aero, tau3d_aero)
+
+             CALL aeropt_lw_rrtm
 #else
 
@@ -2976,5 +2987,5 @@
      !   On prend la somme des fractions nuageuses et des contenus en eau
 
-     if (iflag_cldcon>=5) then
+     if (iflag_cldth>=5) then
 
         do k=1,klev
@@ -3132,5 +3143,5 @@
      calday = REAL(days_elapsed + 1) + jH_cur
 
-     call chemtime(itap+itau_phy-1, date0, dtime)
+     call chemtime(itap+itau_phy-1, date0, dtime, itap)
      IF (config_inca == 'aero' .OR. config_inca == 'aeNP') THEN
         CALL AEROSOL_METEO_CALC( &
@@ -3455,10 +3466,11 @@
   ! Ajouter la tendance des rayonnements (tous les pas)
   !
-  DO k = 1, klev
-     DO i = 1, klon
-        t_seri(i,k) = t_seri(i,k) &
-             + (heat(i,k)-cool(i,k)) * dtime/RDAY
-     ENDDO
-  ENDDO
+  d_t_swr(:,:)=heat(:,:)*dtime/RDAY
+  d_t_lwr(:,:)=-cool(:,:)*dtime/RDAY
+  d_t_sw0(:,:)=heat0(:,:)*dtime/RDAY
+  d_t_lw0(:,:)=-cool0(:,:)*dtime/RDAY
+  CALL add_phys_tend(du0,dv0,d_t_swr,dq0,dql0,dqi0,paprs,'SW')
+  CALL add_phys_tend(du0,dv0,d_t_lwr,dq0,dql0,dqi0,paprs,'LW')
+
   !
   if (mydebug) then
